Subject: bug#23934: 25.1.50; Incorrect rendering of cyrillic text on OS X

From: Alan Third <[email-masked]>
Date: Sun, 10 Jul 2016 17:28:02 +0100

On Sun, Jul 10, 2016 at 07:04:40PM +0300, Eli Zaretskii wrote:
> > From: Alan Third <[email-masked]>
> > Date: Sun, 10 Jul 2016 16:45:51 +0100
> > 
> > When using the font "Menlo" Emacs displays the cyrillic text in the
> > hello file incorrectly. "Monaco" works fine. This affects both Mac and
> > NS ports.
> 
> How do we know it isn't a problem with that font?
> 
> I think the problem is triggered by displaying the u+0301 acute accent
> above the а (to show the vowel with the accent).  Does Menlo has a
> glyph for that codepoint?

Yes, Emacs seems to think that the composed character takes up no
space. This may be no help whatsoever, but I've attached another image
showing a cyrillic a with acute alongside the latin version. The latin
one is not, afaik, composed, because I don't know how to do that. Both
have spaces round them.

I don't know how to check whether the font supports it.
Here's what describe-char says:

             position: 148 of 234 (63%), column: 2
            character: а (displayed as а) (codepoint 1072, #o2060, #x430)
    preferred charset: cyrillic-iso8859-5 (Right-Hand Part of ISO/IEC 8859/5 (Latin/Cyrillic): ISO-IR-144)
code point in charset: 0x50
               script: cyrillic
               syntax: w 	which means: word
             category: .:Base, L:Left-to-right (strong), Y:2-byte Cyrillic, c:Chinese, h:Korean, j:Japanese, y:Cyrillic
             to input: type "C-x 8 RET 430" or "C-x 8 RET CYRILLIC SMALL LETTER A"
          buffer code: #xD0 #xB0
            file code: #xD0 #xB0 (encoded by coding system utf-8-unix)
              display: composed to form "а́" (see below)

Composed with the following character(s) "́" using this font:
  mac-ct:-*-Menlo-normal-normal-normal-*-12-*-*-*-m-0-iso10646-1
by these glyphs:
  [0 1 1072 870 7 0 7 7 1 nil]
  [0 1 769 646 7 2 6 10 -7 [-8 -1 -8]]

Character code properties: customize what to show
  name: CYRILLIC SMALL LETTER A
  general-category: Ll (Letter, Lowercase)
  decomposition: (1072) ('а')

There are text properties here:
  charset              cyrillic-iso8859-5
  face                 font-lock-string-face
  fontified            t

[back]

-- 
Alan Third